/*
 * (c) 1996, 1997, 1998 by Polar Pyramid.
 */


#ifndef AUXIL_H
#define AUXIL_H

#include <string>


#include <sys/types.h>

typedef unsigned char uchar;

#include "config.h"


/*
 * IDs for several log types: 
 *   INFO, WARNING, ERROR, FATAL ERROR, NORMAL TERMINATION.
 */

#define NB_MAGIC_NR  42    // The meaning of life, universe, everything

#define LOGID_INF 1
#define LOGID_WRN 2
#define LOGID_ERR 3
#define LOGID_FAT 4
#define LOGID_TRM 5

/*
 * Inserts for parameter list for logger()
 */

#define LOG_INF LOGID_INF, __FILE__, __LINE__
#define LOG_WRN LOGID_WRN, __FILE__, __LINE__
#define LOG_ERR LOGID_ERR, __FILE__, __LINE__
#define LOG_FAT LOGID_FAT, __FILE__, __LINE__
#define LOG_TRM LOGID_TRM, __FILE__, __LINE__

#ifndef ASSERT
#define ASSERT(Q) if (!(Q)) { auxil_log(LOG_FAT, "Assertion '%s' failed", __STRING(Q)); }
#endif

typedef void (* logfunc_t) (char *log);

extern void auxil_log_set_filename(const std::string &filename);
extern void auxil_log_stdout_write(bool enable);
extern void auxil_log_enable(bool enable);
extern void auxil_log_extrafunc(logfunc_t);
extern void auxil_log_indent_up(void);
extern void auxil_log_indent_down(void);
extern const char *auxil_strip_dir(const char *filename);

extern void auxil_log(
  int logtype,
  char *filename,
  int  linenr,
  const char *format,
  ...
);

extern float auxil_gettime(void);

extern std::string GetRootPath();
extern std::string GetImagePath();
extern std::string GetSoundPath();
extern std::string GetSpritePath();
extern std::string GetWorldPath();
extern std::string GetLogPath();


#endif

