#ifndef TIMER_HH
#define TIMER_HH

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <unistd.h>
#include <sys/time.h>
#include <fcntl.h>
#include <time.h>

#include "auxil.h"

/* usec -> sec : x 0.000001 */

#define USEC_TO_SEC(usec) (0.000001*(usec))

/* msec -> sec : x 0.001 */

#define MSEC_TO_SEC(msec) (0.001*(msec))

/* uclock */

#define UCLOCK_TO_SECONDS(x) (((double) x)/UCLOCKS_PER_SEC)



class Timer
{
  public:

    Timer() : start_time(0.0) 
    {
      Start();
    };

    double TimeSeconds(void)
    {
#if 1
      struct timeval time;
      if (gettimeofday(&time, 0))
        auxil_log(LOG_ERR, "gettimeofday failed");
      return ((double) time.tv_sec + USEC_TO_SEC((double) time.tv_usec));
#else
      return (double) UCLOCK_TO_SECONDS(uclock());
#endif
    }

    void Start(void)
    {
      start_time = TimeSeconds();
    };
    double SecondsElapsed(void)
    {
      return TimeSeconds() - start_time;
    }
 
  private:

    double start_time;
};

#endif

