/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#ifndef INPPAD_H
#define INPPAD_H


#include <string>
#include <vector>

#include "maths.h"
#include "inputdevice.h"


class InputGamePad : public InputDevice
{
  public:
    InputGamePad(const std::string &devfile);
    virtual ~InputGamePad();
    virtual void Update(float dt);
    virtual float GetAxisValue(int id) const;
    virtual bool  GetButtonValue(int id) const;

  protected:
    int fd;
    std::vector<short> AxisValues;
    std::vector<bool>  ButtonValues;
    float DeadMargin;
};

#endif
