/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#include <assert.h>
#include <stdio.h>
#include <X11/Xlib.h>

#include "SDL.h"

#include "auxil.h"
#include "inpsdl.h"


static bool k_l=false, k_r=false, k_u=false, k_d=false;
static bool k_A=false, k_B=false, k_C=false;


InputSDL::InputSDL()
{
  axiscount = 2;
  buttoncount = 3;
  opened = true;
}


InputSDL::~InputSDL()
{
}


void InputSDL::Update(float dt)
{
  SDL_Event event;
  while ( SDL_PollEvent(&event) ) 
  {
    switch (event.type) 
    {
      case SDL_KEYDOWN:
      case SDL_KEYUP:

        if (event.key.keysym.sym==SDLK_LEFT ) k_l = (event.type == SDL_KEYDOWN);
        if (event.key.keysym.sym==SDLK_RIGHT) k_r = (event.type == SDL_KEYDOWN);
        if (event.key.keysym.sym==SDLK_UP   ) k_u = (event.type == SDL_KEYDOWN);
        if (event.key.keysym.sym==SDLK_DOWN ) k_d = (event.type == SDL_KEYDOWN);

        if (event.key.keysym.sym==SDLK_SPACE ) k_A = (event.type == SDL_KEYDOWN);
        if (event.key.keysym.sym==SDLK_LCTRL ) k_B = (event.type == SDL_KEYDOWN);
        if (event.key.keysym.sym==SDLK_ESCAPE) k_C = (event.type == SDL_KEYDOWN);

      break;

      case SDL_QUIT:
         exit(0);
    }
  }
}


float InputSDL::GetAxisValue(int id) const
{
  assert(id<axiscount);
  if (id==0)
  {
    float retval=0.0;
    if (k_r) retval += 1.0;
    if (k_l) retval -= 1.0;
    return retval;
  }
  if (id==1)
  {
    float retval=0.0;
    if (k_u) retval += 1.0;
    if (k_d) retval -= 1.0;
    return retval;
  }
  return 0.0;
}


bool InputSDL::GetButtonValue(int id) const
{
  assert(id<buttoncount);
  if (id==0)
    return k_A;
  if (id==1)
    return k_B;
  if (id==2)
    return k_C;

  return false;
}

