/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#include "auxil.h"

#include "im32.h"

#include "animpres.h"

#include "presdb.h"

#include "numbercloud.h"


NumberCloud::NumberCloud() :
image(Image32(GetImagePath() + "nrs.tif"))
{
  assert((image.w % 10)==0);
}


NumberCloud::~NumberCloud()
{
}


void NumberCloud::Fire(World &wld, int nr)
{
  assert(nr>=0 && nr <= 9);
  int sw = image.w / 10;
  int sh = image.h;
  short *reader = image.data + nr * sw;
  for (int y=0; y<sh; y++)
  {
    for (int x=0; x<sw; x++)
    {
      if (reader[x] == 0 && (rand()&1))
      {
        AnimatedPresence *ap = new AnimatedPresence("nrcloud","wolk",wld);
        Vector3 p(x-sw/2.0, y-sh/2.0, 0);
        Vector2 d((rand()&2047)-1024, (rand()&2047)-1024);
        d.normalize();
        p = 10.0 * p;
        ap->pos = p;
        ap->dir = d;
        ap->vel = 10;
        PresenceDB::TheOne().Add(ap);
      }
    }
    reader += image.w;
  }
}


NumberCloud &NumberCloud::TheOne(void)
{
  static NumberCloud *nc = new NumberCloud();
  return *nc;
}



