/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#include "gfxscreen.h"
#include "world.h"
#include "animpres.h"
#include "spritedb.h"
#include "sprite.h"



AnimatedPresence::AnimatedPresence
(
  const std::string &myname, 
  const std::string &spritenm, 
  const World &wld
) :
Presence(myname, spritenm, wld),
lifelen(3.0),
animlen(0),
looping(false),
lifetime(0.0)
{
  animlen = SpriteDB::TheOne().Get(spritename).framecount;
  autoorient = false;
  insubstantial = true;
}


AnimatedPresence::~AnimatedPresence()
{
}


void AnimatedPresence::Render(const GfxScreen &scn) const
{
  const Sprite &spr = SpriteDB::TheOne().Get(spritename);

  scn.DrawSprite(spr, pos, false, (lifetime/lifelen));
}


void AnimatedPresence::Update(float dt)
{
  Presence::Update(dt);

  lifetime += dt; 
  if (lifetime >= lifelen)
  {
    lifetime = lifelen-0.001;
    dead = true;
  }
}

