/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#include <typeinfo>

#include "enemy.h"


int Enemy::enemy_count = 0;


Enemy::Enemy
(
  const std::string &name,
  const std::string &spritenm, 
  const World &w
) :
  Presence(name, spritenm, w)
{
  vel = 30.0;
  maxvel = 500;
  enemy_count++;
}


Enemy::~Enemy()
{
  enemy_count--;
}


void Enemy::Update(float dt)
{
  Presence::Update(dt); // call parent class update

  // random angular vel change
  if (!(rand()&15))
  {
    switch(rand()&7)
    {
      case 0:
        angularvel =  (rand()&31)/100.0;
        break;
      case 1:
        angularvel = -(rand()&31)/100.0;
        break;
      case 2:
        vel = 0.0;
      case 3:
        acceleration = (rand()&7);
      default:
        angularvel = 0.0;
        break;
    }
  }
  if (vel > maxvel)
    acceleration = -4.0;
}

