/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#ifndef PRESDB_H
#define PRESDB_H

#include <list>

#include <typeinfo>


class GfxScreen;

class Presence;

class PresenceDB;


class PresenceDB
{
  public:

    PresenceDB();
    ~PresenceDB();

    void Render(const GfxScreen &scn) const;

    void Update(float dt);

    void Add(Presence *p);

    void Clear(void);

    int  Size(void) const;

    int Count(const std::type_info &ti) const;

    static PresenceDB &TheOne(void);

  protected:

    std::list<Presence *> presences;
};

#endif

