/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#ifndef PRESENCE_H
#define PRESENCE_H


#include <string>

#include "maths.h"

class World;
class GfxScreen;


class Presence
{
  public:

    Presence
    (
      const std::string &myname, 
      const std::string &spritenm, 
      const World &wld
    );
    ~Presence();

    Vector2 GetVelocityVector(void) const;

    const World &GetWorld(void) const { return theworld; }

    virtual void Render(const GfxScreen &scn) const;

    virtual void Update(float dt);

    std::string name;
    std::string spritename;
    Vector3     pos;
    Vector2     dir;
    Vector2     ori;
    float       vel;
    float       angularvel;
    float       acceleration;
    float       maxvel;
    bool        dead;
    float       radius;
    bool        wallcollision;
    bool        autoorient;
    bool        insubstantial;

  protected:

    Vector3 last_known_good_pos;
    const World &theworld;

};

#endif
