/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#ifndef FRAMEBUF32_H
#define FRAMEBUF32_H

#include <linux/fb.h>


#include "framebuffer.h"

class FrameBuffer32 : public FrameBuffer
{
  public:
    FrameBuffer32();
    virtual ~FrameBuffer32();
    void ZoomBlit(const Image32 &im32, int x, int y);
    virtual void Blit(const Image16 &im16, int x, int y, bool interlace=false)
    {
      assert(0);
    }
    virtual void Blit(const Image32 &im32, int x, int y, bool interlace=false);
    virtual void Clear(void);

  protected:
    int device;
    int w;
    int h;
    int linesize;
    int buffersize;
    int *data;
    
    struct fb_var_screeninfo var_info;
};

#endif
