/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#ifndef FRAMEBUFDGA_H
#define FRAMEBUFDGA_H

#include <linux/fb.h>


#include "framebuffer.h"


struct _XDisplay; // Ugly. I should use 'Display'

class FrameBufferDGA : public FrameBuffer
{
  public:
    FrameBufferDGA();
    ~FrameBufferDGA();
    virtual void Blit(const Image16 &im16, int x, int y, bool interlace=false);
    virtual void Blit(const Image32 &im32, int x, int y, bool interlace=false);
    virtual void Clear(void);
    void Enable(bool e);

  protected:
    bool IsEnabled(void) const { return enabled; }

    struct _XDisplay *dpy;
    int      scn;
    int      bits_per_pixel;
    int      width, height;
    int      pixel_per_line;
    int      bank_size;
    int      ram;
    char    *address;
    bool     enabled;
};

#endif
