/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#ifndef IM32
#define IM32

#include <string>


class Image8;
class Image16;

class Image32
{
  public:

    Image32(const std::string &fname);
    Image32(int ww, int hh);
    Image32(const Image16 &im16);
    ~Image32();
    void Write(const std::string &fname) const;
    void SwapRedBlue(void);
    void ChromaKey(int r, int g, int b);
    Image8 *GetComponent(const std::string &comp) const;
    void SetComponent(const std::string &comp, const Image8 &im8);

    int w,h,maxval;
    unsigned char *data;
    bool has_alpha;
    bool alpha_is_premultiplied;

  protected:
    void ReadPPM (const char *fname);
    void ReadTIFF(const char *fname);
};

#endif

