/*
   File  : rotscr.c
   Author: B&J.Stolk
   Date  : June 1996 
 
   961012 BSt
     rotbuf is now properly malloc'd.
*/

#include <assert.h>

extern "C" 
{
#include <stdio.h>
#include "setup.h"
#include "generated_mkrot_rotoffs.h"
#include "generated_mkrot_pivotoff.h"
#include "generated_mkrot_rotcode.h"
}
#include "alpha.h"
#include "rot.h"


char *rot_reader=0;
char *rot_writer=0;

/*---------------------------------------------------------------------------*/

volatile void rot_rotscr(int r, char *src, char *dst) 
{
  assert(r >= 0);
  assert(r < ROTSTEPS);

  // adjustment for lower-left corner
  char *adjusted_src = src + pivotoffs[r] + (PIVOTY*ROTW - PIVOTX)*2;
  
  volatile const func_t f = funcs[r];

  // For i=0, we get an incorrect line drawn, why?
  for (int i = 1; i < PSCREENH; i++) 
  {
    rot_reader = adjusted_src + rotoffs[r][i];
    rot_writer = dst + i*SPRW*2;
    f();
  }
}

/*---------------------------------------------------------------------------*/

void rot_init(void) 
{
  rot_calculateboundingboxes();
}

