/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "soundchannel.h"


SoundChannel::SoundChannel()
{
  for (int i=0; i<SOUNDCHANNELSIZE; i++)
    packets[i] = 0;
}

SoundChannel::~SoundChannel()
{
  for (int i=0; i<SOUNDCHANNELSIZE; i++)
    delete packets[i];
}

SoundPacket *SoundChannel::Pop(void)
{
  SoundPacket *retval = packets[0];

  int i;
  for (i=0; i<SOUNDCHANNELSIZE-1; i++)
    packets[i] = packets[i+1];
  packets[i] = 0;

  return retval;
}

void SoundChannel::Paste(SoundClip *clip, int delay)
{
  assert(clip);
  assert(clip->data);
  int section = delay / SOUNDPACKETSIZE;
  assert(section<SOUNDCHANNELSIZE);
  int blocks = clip->size / SOUNDPACKETSIZE;
  assert(section+blocks < SOUNDCHANNELSIZE);
  for (int i=0; i<blocks; i++)
  {
    int nr=section+i;
    delete packets[nr];
    packets[nr] = new SoundPacket();
    memcpy(packets[nr]->data, clip->data+i*SOUNDPACKETSIZE, SOUNDPACKETSIZE*sizeof(short));
  }
}

