/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#include <string.h>
#include <stdio.h>
#include <assert.h>

#include "auxil.h"

#include "soundclip.h"

SoundClip::SoundClip(const std::string &nm) :
  name(nm)
{
  short tmp[300000];
  std::string fname = GetSoundPath()+nm+".wav";
  FILE *f=fopen(fname.c_str(),"rb");
  if (!f)
    auxil_log(LOG_INF,"Cannot read sound file '%s'", fname.c_str());
  assert(f);
  size=fread(tmp, sizeof(short), 300000, f);
  assert(size>22);
  size = size-22;
  int md = size % SOUNDPACKETSIZE;
  size = size-md;
  data = new short[size];
  memcpy(data, tmp+22, sizeof(short)*size);
  auxil_log(LOG_INF,"Created soundclip '%s' of size %d", name.c_str(), size);
}


SoundClip::~SoundClip()
{
  delete data;
  data=0;
}


SoundClip *SoundClip::Get(const std::string &name)
{
  clipmap_t::const_iterator ip = clips.find(name);
  if (ip == clips.end())
  {
    clips[name] = new SoundClip(name);
    return clips[name];
  }
  else
  {
    return (*ip).second;
  }
}


clipmap_t SoundClip::clips;

