/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#ifndef SOUNDENGINE_H
#define SOUNDENGINE_H

#include <string>
#include <pthread.h>

#include "soundcfg.h"
#include "soundclip.h"
#include "soundchannel.h"


class SoundEngine
{

  public:
    SoundEngine() : opened(false) {}
    virtual ~SoundEngine() {}

    virtual void Play(const std::string &name, int channel, int delay) = 0;
    static void SetType(const std::string &t);
    static SoundEngine &TheOne(void);

  protected:
    bool opened;
    static std::string reqtype;
    SoundChannel channels[SOUNDCHANNELCOUNT];
};

#endif

