/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#ifndef SOUNDENGINEOSS_H
#define SOUNDENGINEOSS_H

#include <string>
#include <pthread.h>

#include "soundcfg.h"
#include "soundclip.h"
#include "soundchannel.h"
#include "soundengine.h"


class SoundEngineOSS : public SoundEngine
{
  public:
    SoundEngineOSS();
    ~SoundEngineOSS();

    void PlayDirect(const std::string &name);

    int  GetOutputPointer(void);
    int  GetInputPointer(void);
    void Send(void);
    void Sustain(void);
    virtual void Play(const std::string &name, int channel, int delay);

  protected:

    void GetSemaphore(void);
    void ReleaseSemaphore(void);
    static void *UpdateThread(void *job);

    int fd;
    int bytes_written;
    bool semaphore;
    pthread_t thread_id;
};

#endif

