/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#include <assert.h>
#include <stdio.h>

#include "wldprim.h"
#include "primdb.h"



PrimitiveDatabase::PrimitiveDatabase()
{
}


PrimitiveDatabase::~PrimitiveDatabase()
{
}


void PrimitiveDatabase::Add(const std::string &name, unsigned char prt)
{
  primmap_t::iterator ip = prims.find(name);
  assert(ip == prims.end());

  prims[name] = WorldPrimitive(name,prt);
}


const WorldPrimitive &PrimitiveDatabase::Get(const std::string &name) const
{
  primmap_t::const_iterator ip = prims.find(name);
  if (ip == prims.end())
    printf("prim '%s' not found\n", name.c_str());
  assert(ip != prims.end());
  return (*ip).second;
}

