/*
 * Tux vs Clippy
 * (c)2002-2003 by Bram Stolk
 * b.stolk at chello.nl
 * Licensed under GPL
 */

#include <assert.h>
#include <stdio.h>

#include "auxil.h"
#include "im16.h"
#include "im32.h"
#include "wldprim.h"

WorldPrimitive::WorldPrimitive() :
name("noname"),
footprint(0),
im(0)
{
}


WorldPrimitive::WorldPrimitive(const WorldPrimitive &other) :
name(other.name),
footprint(other.footprint),
im(other.im)
{
}


WorldPrimitive::WorldPrimitive(const std::string &thename, unsigned char print):
name(thename),
footprint(print),
im(0)
{
  std::string fname = GetWorldPath()+name+".tif";
  im = new Image16(Image32(fname));
  assert(im->w == 128 && im->h == 128);
}


WorldPrimitive::~WorldPrimitive()
{
//  delete im;
}

